/***********************************************************************
	CommAnalyzer.c
	
	Created:	Saturday, July 24, 1993, 12:45 AM
	Project:	Comm Analyzer.
	Compiler:	6.0,  Symantec Corporation 1993
	By:			Greg Ames

	Copyright  1993,1993 Ames & Associates.
	All rights reserved. 

	AppleLink:AMES
	AOL:AMES
	Compuserve:73177,1603

***********************************************************************/

#include <Serial.h>
#include <QDOffscreen.h>
#include "CommAnalyzer.h"

//***********************************************************************/

Rect 	theRect[32];
Rect	mainRect = {0,0,high,width};
BitMap	theMap;
char	hex[] = "0123456789ABCDEF";
short	slot;

extern  GWorldPtr gMyOffG;	// Pointer to OffScreen Graphics World
short 	mode = 1;

void	blastHex(short	val, short x, short y, short channel);
short 	chaBuffer[kCapture],chbBuffer[kCapture];

short	lastv = -1;
short	lastv1 = -1;


//***********************************************************************/

void initAnalyser()
{
	
	PicHandle	thePict;
	short	loop,next = 0;
	Rect	aRect;
	long 	now;	

	TextFont(courier);
	TextSize(9);
	for (loop = 0;loop<16;loop++)
	{
		theRect[loop] = mainRect;
		OffsetRect(&mainRect,4,0);
	}
	
	SetRect(&mainRect,0,0,width,high);
	OffsetRect(&mainRect,0,high);
	
	for (loop = 16;loop<32;loop++)
	{
		theRect[loop] = mainRect;
		OffsetRect(&mainRect,width,0);
	}
	
	startOffscreen();
	
	clearBuffer();
	
	theMap = thePort->portBits;
	
}

//***********************************************************************/

void	clearBuffer()
{	short	loop;
	for (loop = 0;loop<kCapture;loop++)
	{
		chaBuffer[loop] = -1;
		chbBuffer[loop] = -1;
	}
	reDraw();
	slot = 0;
}

//***********************************************************************/

void	reDraw()
{
	short	loop;
	PicHandle	thePict;
	Rect	aRect;
	
	short	tempslot = slot;
	
	for (loop=0;loop<kLastSlot;loop++)
	{
		blastHex(chaBuffer[loop],loop & 0x3f, loop >> 6,0);
		blastHex(chbBuffer[loop],loop & 0x3f, loop >> 6,1);
	}
	slot = tempslot;
}

//***********************************************************************/

void idleAnalyser()
{
	char buffer[256];
	short loop,err;
	long	count;
	
	if (ain)
	{
		err = SerGetBuf(ain,&count);
		if (count >255)
			count = 255;
		if (count)
		{
			err = FSRead(ain,&count,& buffer);
			for (loop = 0;loop<count;loop++)
			{
				blastHex(buffer[loop],slot & 0x3f, slot >> 6,0);
				chaBuffer[slot] = buffer[loop];
				chbBuffer[slot] = -1;
				slot++;
				if (slot>kLastSlot)
					slot = 0;
			}
		}
	}
	
	if (bin)
	{
		err = SerGetBuf(bin,&count);
		if (count >255)
			count = 255;
		if (count)
		{
			err = FSRead(bin,&count,& buffer);
			for (loop = 0;loop<count;loop++)
			{
				blastHex(buffer[loop],slot & 0x3f, slot >> 6,1);
				chaBuffer[slot] = -1;
				chbBuffer[slot] = buffer[loop];
				slot++;
				if (slot>kLastSlot)
					slot = 0;
			}
		}
	}
}

//***********************************************************************/

void	blastHex(short	val, short x, short y , short channel)
{
	Rect		aRect = {0,0,high,width};
	
	
	theMap =thePort->portBits;
	OFFSETRECT(aRect,x*kHexWidth+kOffsetWidth,y*kHexHigh+kOffsetHigh);


	if (lastv!=y)
	{
		Rect	tRect = aRect;
		
		tRect.bottom +=high;
		tRect.right +=1000;
		tRect.left = 0;
		EraseRect(&tRect);
		lastv=y;

		SetRect(&tRect,0,0,width,high);
		OFFSETRECT(tRect,kOffsetWidth,y*kHexHigh+kOffsetHigh+high*2);
		tRect.bottom +=high;
		tRect.right +=64*kHexWidth;
		PaintRect(&tRect);
	}

	if (val==-1) 
		return;
	val &=0xff;

	if (!channel)	//channel 1
	{
		switch (mode)
		{
			case 2:
				if (val>=' ')
				{
					MoveTo(aRect.left,aRect.bottom+3);
					DrawChar(val);
					break;
				}
	
			case 1:
				CopyBits((BitMap *) (*(gMyOffG->portPixMap)),&theMap,&theRect[(val >> 4) ],&aRect,srcCopy,0L);
				OFFSETRECT(aRect,width,high);
				CopyBits( (BitMap *) (*(gMyOffG->portPixMap)),&theMap,&theRect[(val % 16) ],&aRect,srcCopy,0L);
				break;
		}
	}
	else	// channel 2
	{
		OFFSETRECT(aRect,0,high*2);

		switch (mode)
		{
			case 2:
				if (val>=' ')
				{
					TextMode(srcXor);
					MoveTo(aRect.left,aRect.bottom+3);
					DrawChar(val);
					TextMode(srcCopy);
					break;
				}
	
			case 1:
				CopyBits( (BitMap *) (*(gMyOffG->portPixMap)),&theMap,&theRect[(val >> 4) + 16],&aRect,srcCopy,0L);
				OFFSETRECT(aRect,width,high);
				CopyBits( (BitMap *) (*(gMyOffG->portPixMap)),&theMap,&theRect[(val % 16) + 16],&aRect,srcCopy,0L);
				break;
		}
	}
}