/***********************************************************************
	CommAnalyzerMenus.c
	
	Created:	Wednesday, April 21, 1993, 11:26 AM
	Project:	CommAnalyzer.
	Compiler:	6.0,  Symantec Corporation 1993
	By:			Greg Ames

	Copyright  1993,1993 Ames & Associates.
	All rights reserved. 

	AppleLink:AMES
	AOL:AMES
	Compuserve:73177,1603

***********************************************************************/

#include <Serial.h>
#include "CommAnalyzer.h"
#include "CommAnalyzerMenus.h"

#define	baud38400 1

// first value is default

short	baudval[] =     {baud38400,baud300,baud1200,baud2400,baud4800,baud9600,baud19200, baud38400, baud57600};
short	dataval[] = 	{data8,data8,data7};
short	parityval[] = 	{noParity,noParity,oddParity,evenParity};
short	stopval	[]	=	{stop10,stop10,stop15,stop20};

void	reDraw(void);
void	clearBuffer(void);

short	lastBaud= 7,lastData = 1 ,lastParity = 1 ,lastStop = 1 ,lastHandshake = 1 ;

MenuHandle	appleMenu, fileMenu, editMenu, modeMenu,configMenu,bitsMenu,parityMenu,stopMenu,handMenu;

enum	{
	appleID = 128,
	fileID,
	editID,
	modeID,
	configID,
	dataPop = 32,
	parityPop,
	stopPop,
	handPop
	};

enum	{
	loadItem = 1,
	saveItem,
	quitItem = 4
	};

enum
{
	kUndo=1,
	kCut =3,
	kCopy,
	kPaste,
	kClearBuffer= 7,
	kFlush
};

/****
 * SetUpMenus()
 *
 *	Set up the menus. Normally, wed use a resource file, but
 *	for this example well supply hardwired strings.
 *
 ****/
 
//***********************************************************************/


void SetUpMenus(void)

{
	MenuHandle	theHier;
	short	loop;
	
	Handle	hMbar = GetNewMBar ( 128 );
	SetMenuBar ( hMbar );
	
	appleMenu = GetMHandle(appleID);
	modeMenu = GetMHandle(modeID);
	
	InsertMenu(configMenu = GetMenu(configID),hierMenu);
	CheckItem(configMenu, lastBaud, true);

	InsertMenu(bitsMenu = 	GetMenu(dataPop),hierMenu);
	CheckItem(bitsMenu, lastData, true);

	InsertMenu(parityMenu = GetMenu(parityPop),hierMenu);
	CheckItem(parityMenu, lastParity, true);

	InsertMenu(stopMenu = 	GetMenu(stopPop),hierMenu);
	CheckItem(stopMenu, lastStop, true);

	InsertMenu(handMenu = 	GetMenu(handPop),hierMenu);
	CheckItem(handMenu, lastHandshake, true);

	DrawMenuBar();
	AddResMenu(appleMenu, 'DRVR');
}
/* end SetUpMenus */


/****
 *  AdjustMenus()
 *
 *	Enable or disable the items in the Edit menu if a DA window
 *	comes up or goes away. Our application doesn't do anything with
 *	the Edit menu.
 *
 ****/

static void enable (MenuHandle menu, short item, short ok);

void AdjustMenus(void)
{
	register WindowPeek wp = (WindowPeek) FrontWindow();
	short kind = wp ? wp->windowKind : 0;
	Boolean DA = kind < 0;
	
	enable(editMenu, 1, DA);
	enable(editMenu, 3, DA);
	enable(editMenu, 4, DA);
	enable(editMenu, 5, DA);
	enable(editMenu, 6, DA);
	
}

//***********************************************************************/

static
void enable(MenuHandle menu, short item, short ok)
{
	if (ok)
		EnableItem(menu, item);
	else
		DisableItem(menu, item);
}

//***********************************************************************/
/*****
 * HandleMenu(mSelect)
 *
 *	Handle the menu selection. mSelect is what MenuSelect() and
 *	MenuKey() return: the high word is the menu ID, the low word
 *	is the menu item
 *
 *****/

void HandleMenu (long mSelect)

{
	int			menuID = HiWord(mSelect);
	int			menuItem = LoWord(mSelect);
	Str255		name;
	GrafPtr		savePort;
	WindowPeek	frontWindow;
	
	switch (menuID)
	  {
	  case	appleID:
	  {
		switch (menuItem)

		{	case 1:
				Alert(128,0L);
				break;
			default:
				GetPort(&savePort);
				GetItem(appleMenu, menuItem, name);
				OpenDeskAcc(name);
				SetPort(savePort);
				break;
		}
		break;
	  }
	
	  case	fileID:
		switch (menuItem)
		  {
		  case	loadItem:
			loadFile();
			break;
  				  			
		  case	saveItem:
			saveFile();
 			break;
  				  	
		  case	quitItem:
			ExitToShell();
			break;
		  }
		break;
  				
	  case	editID:
	  	switch (menuItem)
	  	{ short err;
	  		case kClearBuffer:
		  		clearBuffer();
		  		break;
	  		case kFlush:
		  		err = KillIO(ain);
		  		err = KillIO(bin);
		  		break;
		  		
	  	}
//		if (!SystemEdit(menuItem-1))
//		  SysBeep(5);
		break;
		
	  case	modeID:
		CheckItem(modeMenu, mode, false);
		mode = menuItem;
		CheckItem(modeMenu, mode, true);
		reDraw();
		break;
	  case configID:
	  {
		CheckItem(configMenu, lastBaud, false);
		lastBaud = menuItem;
		CheckItem(configMenu, lastBaud, true);
		goto	doSerial;
		break;
	  }
	  case dataPop:
	  {
		CheckItem(bitsMenu, lastData, false);
		lastData = menuItem;
		CheckItem(bitsMenu, lastData, true);
		goto	doSerial;
	  	break;
	  }
	  case parityPop:
	  {
		CheckItem(parityMenu, lastParity, false);
		lastParity = menuItem;
		CheckItem(parityMenu, lastParity, true);
		goto	doSerial;
	  	break;
	  }
	  case stopPop:
	  {
		CheckItem(stopMenu, lastStop, false);
		lastStop = menuItem;
		CheckItem(stopMenu, lastStop, true);
		goto	doSerial;
	  	break;
	  }
	  case handPop:
	  {
		CheckItem(handMenu, lastHandshake, false);
		lastHandshake = menuItem;
		CheckItem(handMenu, lastHandshake, true);
		goto	doSerial;
	  	break;
	  }
doSerial:
	  {
	  	short	config,iErr;
	  	
	  	config	= baudval[lastBaud] + dataval[lastData] + parityval[lastParity] + stopval[lastStop];

	  	iErr = SerReset ( aout, config );
	  	iErr = SerReset ( bout, config );
	  	iErr = SerReset ( ain, config );
	  	iErr = SerReset ( bin, config );
	  	break;
	  }	  
	  default:
	  {
//	  	Debugger();
	  }
	  }
}
/* end HandleMenu */

