/***********************************************************************
	CommAnalyzerOffScreen.c
	
	Created:	Sunday, July 25, 1993, 9:34 PM
	Project:	CommAnalyzer.
	Compiler:	6.0,  Symantec Corporation 1993
	By:			Greg Ames

	Copyright  1993,1993 Ames & Associates.
	All rights reserved. 

	AppleLink:AMES
	AOL:AMES
	Compuserve:73177,1603

***********************************************************************/

#include <QDOffscreen.h>
#include "CommAnalyzer.h"

#define	high	5

GWorldPtr gMyOffG;	// Pointer to OffScreen Graphics World

//***********************************************************************/

void startOffscreen()
{
	Rect rBounds; 	// Bounding rectangle of sample window
	Rect r;	// Rect used to display icon in
	short	loop;
	PicHandle	thePict;
	Rect	aRect;
	
	// Offscreen world variables
	GWorldPtr currPort;    // Saves the current port prior to setting up
							// offscreen world
	GDHandle currDev;       // Saves the current device prior to setting up
							// offscreen world
	short err;                    //  error returned from

	static Rect dOffBounds = {0,0,360,360};   // Bounds of OffScreen Graphics
													// World

	thePict = GetPicture(128);
	
	aRect = (*thePict)->picFrame;
	OffsetRect(&(*thePict)->picFrame,-(*thePict)->picFrame.left,-(*thePict)->picFrame.top);
	aRect.bottom+=high;
	
		// Build Offscreen Graphics world
		GetGWorld(&currPort,&currDev);

		// Create Offscreen Graphics world.
		err = NewGWorld(&gMyOffG, 0, &aRect, nil, nil, 0);

		if (!err) {
			// Lock down Pixels that we are drawing to so that memory will not
			// move
			LockPixels (gMyOffG->portPixMap);
			// Setup drawing area to be our offscreen graphics world
			SetGWorld (gMyOffG, nil);
			// Plot Icon

			// Clear Rectangle, so that CopyBits will not copy extra background
			EraseRect (&aRect);
			
			aRect = (*thePict)->picFrame;
			DrawPicture(thePict,&(*thePict)->picFrame);
			OffsetRect(&aRect,0,high);
			DrawPicture(thePict,&aRect);
			InvertRect(&aRect);

			// Done drawing, now reset Port etc.
			SetGWorld (currPort, currDev);

			// Now copy offscreen drawing to Window

			// Set ForeColor to black, and BackColor to white
			// NOTE:  This is necessary to prevent copybits from displaying
			// unwanted colors  in the copied image.
			ForeColor (blackColor);
			BackColor (whiteColor);

	}
}
